"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const _ = require("underscore");
const Router = require("koa-router");
const compose = require("koa-compose");
const declarations_1 = require("./declarations");
class A7Controller {
    get $koaRouter() {
        if (this.$router != null) {
            return this.$router;
        }
        const constructor = this.constructor;
        const meta = Reflect.getMetadata(declarations_1.METADATA_KEY, constructor);
        if (meta == null) {
            return null;
        }
        this.$router = new Router(meta.routerOptions);
        for (const middleware of meta.middlewares) {
            this.$router.use(middleware);
        }
        for (const handler in meta.handlers) {
            const handlerMeta = meta.handlers[handler];
            let method = this[handler];
            if (method != null) {
                method = _.bind(method, this);
            }
            else {
                method = _.identity;
            }
            if (handlerMeta.middleware != null) {
                method = compose([handlerMeta.middleware, method]);
                this[handler] = method;
            }
            this.$router[handlerMeta.method](handlerMeta.path, method);
        }
        return this.$router;
    }
    get $koaRouterUseArgs() {
        return [this.$koaRouter.routes(), this.$koaRouter.allowedMethods()];
    }
}
exports.A7Controller = A7Controller;

//# sourceMappingURL=controller.js.map
