"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("underscore");
const validator = require("validator");
const params_1 = require("./params");
/* tslint:disable:rule1 no-shadowed-variable */
const dotty = require('dotty');
const required = (target, path, val) => val != null;
exports.required = required;
function contains(seed) {
    const contains = (target, path, val) => val == null || validator.contains(val, seed);
    return contains;
}
exports.contains = contains;
function equals(comparison) {
    const equals = (target, path, val) => val == null || validator.equals(val, comparison);
    return equals;
}
exports.equals = equals;
function isAfter(date) {
    const isAfter = (target, path, val) => val == null || validator.isAfter(val, date);
    return isAfter;
}
exports.isAfter = isAfter;
function isAlpha(locale) {
    const isAlpha = (target, path, val) => val == null || validator.isAlpha(val, locale);
    return isAlpha;
}
exports.isAlpha = isAlpha;
function isAlphanumeric(locale) {
    const isAlphanumeric = (target, path, val) => val == null || validator.isAlphanumeric(val, locale);
    return isAlphanumeric;
}
exports.isAlphanumeric = isAlphanumeric;
const isAscii = (target, path, val) => val == null || validator.isAscii(val);
exports.isAscii = isAscii;
const isBase64 = (target, path, val) => val == null || validator.isBase64(val);
exports.isBase64 = isBase64;
function isBefore(date) {
    const isBefore = (target, path, val) => val == null || validator.isBefore(val, date);
    return isBefore;
}
exports.isBefore = isBefore;
const isBoolean = (target, path, val) => val == null || validator.isBoolean(val);
exports.isBoolean = isBoolean;
function isByteLength(a, b) {
    const isByteLength = (target, path, val) => val == null || validator.isByteLength(val, a, b);
    return isByteLength;
}
exports.isByteLength = isByteLength;
const isCreditCard = (target, path, val) => validator.isCreditCard(val);
exports.isCreditCard = isCreditCard;
function isCurrency(options) {
    const isCurrency = (target, path, val) => val == null || validator.isCurrency(val, options);
    return isCurrency;
}
exports.isCurrency = isCurrency;
const isDataURI = (target, path, val) => val == null || validator.isDataURI(val);
exports.isDataURI = isDataURI;
function isDecimal(options) {
    const isDecimal = (target, path, val) => val == null || validator.isDecimal(val, options);
    return isDecimal;
}
exports.isDecimal = isDecimal;
function isDivisibleBy(number) {
    const isDivisibleBy = (target, path, val) => val == null || validator.isDivisibleBy(val, number);
    return isDivisibleBy;
}
exports.isDivisibleBy = isDivisibleBy;
function isEmail(options) {
    const isEmail = (target, path, val) => val == null || validator.isEmail(val, options);
    return isEmail;
}
exports.isEmail = isEmail;
const isEmpty = (target, path, val) => val == null || validator.isEmpty(val);
exports.isEmpty = isEmpty;
function isEnum(enumObject) {
    const values = _.values(enumObject);
    const isEnum = (target, path, val) => val == null || _.indexOf(values, val) >= 0;
    return isEnum;
}
exports.isEnum = isEnum;
function isFQDN(options) {
    const isFQDN = (target, path, val) => val == null || validator.isFQDN(val, options);
    return isFQDN;
}
exports.isFQDN = isFQDN;
function isFloat(options) {
    const isFloat = (target, path, val) => val == null || validator.isFloat(val, options);
    return isFloat;
}
exports.isFloat = isFloat;
const isFullWidth = (target, path, val) => val == null || validator.isFullWidth(val);
exports.isFullWidth = isFullWidth;
const isHalfWidth = (target, path, val) => val == null || validator.isHalfWidth(val);
exports.isHalfWidth = isHalfWidth;
function isHash(algorithm) {
    const isHash = (target, path, val) => val == null || validator.isHash(val, algorithm);
    return isHash;
}
exports.isHash = isHash;
const isHexColor = (target, path, val) => val == null || validator.isHexColor(val);
exports.isHexColor = isHexColor;
const isHexadecimal = (target, path, val) => val == null || validator.isHexadecimal(val);
exports.isHexadecimal = isHexadecimal;
function isIP(version) {
    const isIP = (target, path, val) => val == null || validator.isIP(val, version);
    return isIP;
}
exports.isIP = isIP;
function isISSN(options) {
    const isISSN = (target, path, val) => val == null || validator.isISSN(val, options);
    return isISSN;
}
exports.isISSN = isISSN;
const isISIN = (target, path, val) => val == null || validator.isISIN(val);
exports.isISIN = isISIN;
const isISO8601 = (target, path, val) => val == null || validator.isISO8601(val);
exports.isISO8601 = isISO8601;
const isISO31661Alpha2 = (target, path, val) => val == null || validator.isISO31661Alpha2(val);
exports.isISO31661Alpha2 = isISO31661Alpha2;
const isISRC = (target, path, val) => val == null || validator.isISRC(val);
exports.isISRC = isISRC;
function isIn(values) {
    const isIn = (target, path, val) => val == null || validator.isIn(val, values);
    return isIn;
}
exports.isIn = isIn;
function isInt(options) {
    const isInt = (target, path, val) => val == null || validator.isInt(val, options);
    return isInt;
}
exports.isInt = isInt;
const isJSON = (target, path, val) => val == null || validator.isJSON(val);
exports.isJSON = isJSON;
const isLatLong = (target, path, val) => val == null || validator.isLatLong(val);
exports.isLatLong = isLatLong;
function isLength(a, b) {
    const isLength = (target, path, val) => {
        if (val == null) {
            return true;
        }
        else if (_.isArray(val)) {
            return a <= val.length && (b == null || val.length <= b);
        }
        else {
            return validator.isLength(val, a, b);
        }
    };
    return isLength;
}
exports.isLength = isLength;
const isString = (target, path, val) => val == null || _.isString(val);
exports.isString = isString;
const isArray = (target, path, val) => val == null || _.isArray(val);
exports.isArray = isArray;
const isNumber = (target, path, val) => val == null || _.isNumber(val);
exports.isNumber = isNumber;
const isLowercase = (target, path, val) => val == null || validator.isLowercase(val);
exports.isLowercase = isLowercase;
const isMACAddress = (target, path, val) => val == null || validator.isMACAddress(val);
exports.isMACAddress = isMACAddress;
const isMD5 = (target, path, val) => val == null || validator.isMD5(val);
exports.isMD5 = isMD5;
const isMimeType = (target, path, val) => val == null || validator.isMimeType(val);
exports.isMimeType = isMimeType;
function isInRange(min, max) {
    const isInRange = (target, path, val) => {
        return val == null || (val >= min && (max == null || val <= max));
    };
    return isInRange;
}
exports.isInRange = isInRange;
function isMobilePhone(locale, options) {
    const isMobilePhone = (target, path, val) => val == null || validator.isMobilePhone(val, locale, options);
    return isMobilePhone;
}
exports.isMobilePhone = isMobilePhone;
const isMongoId = (target, path, val) => val == null || validator.isMongoId(val);
exports.isMongoId = isMongoId;
const isMultibyte = (target, path, val) => val == null || validator.isMultibyte(val);
exports.isMultibyte = isMultibyte;
const isNumeric = (target, path, val) => val == null || validator.isNumeric(val);
exports.isNumeric = isNumeric;
const isPort = (target, path, val) => val == null || validator.isPort(val);
exports.isPort = isPort;
function isPostalCode(locale) {
    const isPostalCode = (target, path, val) => val == null || validator.isPostalCode(val, locale);
    return isPostalCode;
}
exports.isPostalCode = isPostalCode;
const isSurrogatePair = (target, path, val) => val == null || validator.isSurrogatePair(val);
exports.isSurrogatePair = isSurrogatePair;
function isURL(options) {
    const isURL = (target, path, val) => val == null || validator.isURL(val, options);
    return isURL;
}
exports.isURL = isURL;
function isUUID(version) {
    const isUUID = (target, path, val) => val == null || validator.isUUID(val, version);
    return isUUID;
}
exports.isUUID = isUUID;
const isUppercase = (target, path, val) => val == null || validator.isUppercase(val);
exports.isUppercase = isUppercase;
const isVariableWidth = (target, path, val) => val == null || validator.isVariableWidth(val);
exports.isVariableWidth = isVariableWidth;
function isWhitelisted(chars) {
    const isWhitelisted = (target, path, val) => val == null || validator.isWhitelisted(val, chars);
    return isWhitelisted;
}
exports.isWhitelisted = isWhitelisted;
function matches(pattern, modifiers) {
    const matches = (target, path, val) => val == null || validator.matches(val, pattern, modifiers);
    return matches;
}
exports.matches = matches;
// --------------------------- Sanitizers ----------------------------------- //
function blacklist(chars) {
    const blacklist = (target, path, val) => {
        if (val != null) {
            dotty.put(target, path, validator.blacklist(val, chars));
        }
        return true;
    };
    return blacklist;
}
exports.blacklist = blacklist;
function escape(target, path, val) {
    if (val != null) {
        dotty.put(target, path, validator.escape(val));
    }
    return true;
}
exports.escape = escape;
function unescape(target, path, val) {
    if (val != null) {
        dotty.put(target, path, validator.unescape(val));
    }
    return true;
}
exports.unescape = unescape;
function ltrim(chars) {
    const ltrim = (target, path, val) => {
        if (val != null) {
            dotty.put(target, path, validator.ltrim(val, chars));
        }
        return true;
    };
    return ltrim;
}
exports.ltrim = ltrim;
function normalizeEmail(options) {
    const normalizeEmail = (target, path, val) => {
        if (val != null) {
            dotty.put(target, path, validator.normalizeEmail(val, options));
        }
        return true;
    };
    return normalizeEmail;
}
exports.normalizeEmail = normalizeEmail;
function rtrim(chars) {
    const rtrim = (target, path, val) => {
        if (val != null) {
            dotty.put(target, path, validator.rtrim(val, chars));
        }
        return true;
    };
    return rtrim;
}
exports.rtrim = rtrim;
function stripLow(keep_new_lines) {
    const stripLow = (target, path, val) => {
        if (val != null) {
            dotty.put(target, path, validator.stripLow(val, keep_new_lines));
        }
        return true;
    };
    return stripLow;
}
exports.stripLow = stripLow;
function toBoolean(strict) {
    const toBoolean = (target, path, val) => {
        if (val != null && !_.isBoolean(val)) {
            dotty.put(target, path, validator.toBoolean(val, strict));
        }
        return true;
    };
    return toBoolean;
}
exports.toBoolean = toBoolean;
function toDate(target, path, val) {
    if (val != null && !_.isDate(val)) {
        dotty.put(target, path, validator.toDate(val));
    }
    return true;
}
exports.toDate = toDate;
function toFloat(target, path, val) {
    if (val != null && !_.isNumber(val)) {
        dotty.put(target, path, validator.toFloat(val));
    }
    return true;
}
exports.toFloat = toFloat;
function toInt(radix) {
    const toInt = (target, path, val) => {
        if (val != null) {
            const value = _.isNumber(val)
                ? Math.floor(val)
                : validator.toInt(val, radix);
            dotty.put(target, path, value);
        }
        return true;
    };
    return toInt;
}
exports.toInt = toInt;
function trim(chars) {
    const trim = (target, path, val) => {
        if (val != null) {
            dotty.put(target, path, validator.trim(val, chars));
        }
        return true;
    };
    return trim;
}
exports.trim = trim;
function whitelist(chars) {
    const whitelist = (target, path, val) => {
        if (val != null) {
            dotty.put(target, path, validator.whitelist(val, chars));
        }
        return true;
    };
    return whitelist;
}
exports.whitelist = whitelist;
function split(separator = ',', restricted = false) {
    const split = (target, path, val) => {
        if (val != null && !_.isString(val)) {
            return !restricted;
        }
        if (val != null) {
            dotty.put(target, path, val.split(separator));
        }
        return true;
    };
    return split;
}
exports.split = split;
function withDefault(option) {
    const withDefault = (target, path, val, root) => {
        if (val == null) {
            val = _.isFunction(option) ? option(root) : option;
            dotty.put(target, path, val);
        }
        return true;
    };
    return withDefault;
}
exports.withDefault = withDefault;
function map(fn) {
    const map = (target, path, val, root) => {
        if (val != null) {
            val = fn(val, root);
            dotty.put(target, path, val);
        }
        return true;
    };
    return map;
}
exports.map = map;
function array(options) {
    const selfValidators = _.isArray(options) || _.isFunction(options) ? _.flatten([options]) : [];
    const mappedOptions = _.isArray(options) || _.isFunction(options)
        ? []
        : _.map(options, (v, key) => {
            const vs = _.chain([v])
                .flatten()
                .filter(x => !!x)
                .value();
            if (key.startsWith('!')) {
                vs.push(required);
                key = key.substring(1);
            }
            return { key, validators: vs };
        });
    const array = (target, path, val, root) => {
        if (val == null) {
            return;
        }
        if (!_.isArray(val)) {
            return 'not an array';
        }
        const errors = [];
        _.each(val, (v, index) => {
            for (const fn of selfValidators) {
                const uv = val[index];
                const pass = fn(val, index, uv, root);
                if (pass === false || _.isString(pass)) {
                    errors.push({
                        path: index,
                        value: uv,
                        failed: fn.name,
                        reason: pass || '',
                    });
                }
                if (_.isArray(pass)) {
                    for (const error of pass) {
                        errors.push({
                            path: index + '.' + error.path,
                            value: error.value,
                            failed: fn.name + '>' + error.failed,
                            reason: error.reason,
                        });
                    }
                }
            }
            const nerrors = params_1.processValidators(val[index], mappedOptions, root);
            for (const error of nerrors) {
                errors.push({
                    path: index + '.' + error.path,
                    value: error.value,
                    failed: error.failed,
                    reason: error.reason,
                });
            }
        });
        return errors;
    };
    return array;
}
exports.array = array;

//# sourceMappingURL=validators.js.map
